/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Drag de Go code.
 *
 * The Initial Developer of the Original Code is
 * Yukichi Kamata.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either of the GNU General Public License Version 2 or later (the "GPL"),
 * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
var nsCI = Components.interfaces;
var Cc = Components.classes;
var ddg_Prefs = {
	plugData: null,
	onLoad : function(){
		this.CharMenu.onLoad();
		this.init();
		this.getLastTabs();
		window.addEventListener("command", ddg_Prefs.enableApply, false);
		window.addEventListener("change", ddg_Prefs.enableApply, false);
		window.addEventListener("close", ddg_Prefs.onClose, false);
		setTimeout(window.sizeToContent, 0);
	},
	
	init : function(){
		ddg_Preferences.loadPrefs();
		this.updateState();
		TimeoutCntl.onLoad();
		Indicator.onLoad();
		this.setGesture();
	},
	
	updateState : function(){
		with(ddg_Preferences.Prefs){
			document.getElementById('ddg-open-otherapp').value = OpenIn[0];
			document.getElementById('ddg-open-outof').value = OpenIn[1];
			document.getElementById('showTooltip').checked = showTooltip;
			document.getElementById('moveEnable').checked = moveEnable;
			document.getElementById('ConfirmSaving').checked = ConfirmSaving;
			document.getElementById('ShowAddFolderMenu').checked = ShowAddFolderMenu;
			document.getElementById('ShowOptionMenu').checked = ShowOptionMenu;
			document.getElementById('ShowSaveAsMenu').checked = ShowSaveAsMenu;
			document.getElementById('enableToChangeUrlGest').checked = enableToChangeUrlGest;
			document.getElementById('EnableTimeout').checked = EnableTimeout;
			document.getElementById('ShowDragContext').checked = DragContextButton >= 0;
			document.getElementById('ShowProgress').checked = ShowProgress;
			document.getElementById('DragContextButton').selectedIndex = DragContextButton < 0 ? 0 : DragContextButton;
			document.getElementById('CharSet').value = CharSet;
			var Menus = document.getElementById("dragContextMenus");
			var currentWindow = ddgUtils.MostRecentWindow('navigator:browser');
			Menus.lastChild.hidden = !('gFlashGot' in currentWindow);
			for (var i=0,h=0; i<Menus.childNodes.length; i++){
				if(Menus.childNodes[i].nodeName == "checkbox"){
					Menus.childNodes[i].checked = DragContextMenus[h] ? true : false;
					h++;
				}
			}
		}
	},
	
	checkState : function(){
		with(ddg_Preferences.Prefs){
			OpenIn[0] = document.getElementById('ddg-open-otherapp').value;
			OpenIn[1] = document.getElementById('ddg-open-outof').value;
			showTooltip = document.getElementById('showTooltip').checked;
			moveEnable = document.getElementById('moveEnable').checked;
			ConfirmSaving = document.getElementById('ConfirmSaving').checked;
			ShowAddFolderMenu = document.getElementById('ShowAddFolderMenu').checked;
			ShowOptionMenu = document.getElementById('ShowOptionMenu').checked;
			ShowSaveAsMenu = document.getElementById('ShowSaveAsMenu').checked;
			enableToChangeUrlGest = document.getElementById('enableToChangeUrlGest').checked;
			EnableTimeout = document.getElementById('EnableTimeout').checked;
			ShowProgress = document.getElementById('ShowProgress').checked;
			DragContextButton = !document.getElementById('ShowDragContext').checked ? -1 :
									document.getElementById('DragContextButton').selectedIndex;
			CharSet = document.getElementById('CharSet').value;
			TimeoutPeriod = TimeoutCntl.TimeoutPeriod;
			tipStyle = Indicator.Data;
			Taction = this.currentAction('text');
			Iaction = this.currentAction('img');
			Laction = this.currentAction('link');
			Xaction = this.currentAction('addon');
			Saction = this.currentAction('source');
			var Menus = document.getElementById("dragContextMenus");
			for (var i=0,h=0; i<Menus.childNodes.length; i++){
				if(Menus.childNodes[i].nodeName == "checkbox"){
					DragContextMenus[h] = Menus.childNodes[i].checked ? 1 : "";
					h++;
				}
			}
		}
	},
	
	currentAction : function(Type){
		function setAction(aId){
			var mItem = document.getElementById(aId);
			var mValue = mItem._selectedItem;
			if(mItem._plugData)
				mValue += ("--"+ mItem._plugData);
			return mValue;
		}
		
		var aAction = [];
		aAction.push(document.getElementById('direction-' + Type)._selectedIndex);
		aAction.push(setAction(Type +'-ddg-right'));
		aAction.push(setAction(Type +'-ddg-left'));
		aAction.push(setAction(Type +'-ddg-down'));
		aAction.push(setAction(Type +'-ddg-up'));
		return aAction;
	},
	
	setGesture : function(){
		with(ddg_Preferences.Prefs){
			var Actions = [Taction, Iaction, Laction, Xaction, Saction];
			var Type = ['text', 'img', 'link', 'addon', 'source'];
			for(i in Actions)
				Action(Type[i] ,Actions[i]);
		}
		
		function Action(gesture ,data){
			document.getElementById('direction-' + gesture)._selectedIndex = parseInt(data[0]);
			setAction(data[1] , gesture + '-ddg-right' );
			setAction(data[2] , gesture + '-ddg-left' );
			setAction(data[3] , gesture + '-ddg-down' );
			setAction(data[4] , gesture + '-ddg-up' );
		}
		
		function setAction(actionIndex ,actionItem){
			if(/.+--.+/.test(actionIndex)){
				var action = actionIndex.split("--");
				document.getElementById(actionItem)._selectedItem = action[0];
				document.getElementById(actionItem)._plugData = action[1];
				document.getElementById(actionItem)._Src = ddg_Search.getIconURL(action[1]);
			}else{
				document.getElementById(actionItem)._Src = null;
				document.getElementById(actionItem)._selectedItem = actionIndex;
				document.getElementById(actionItem)._plugData = null;
			}
		}
	},
	
	selectTab : function(tabIndex){
		tabIndex = tabIndex ? tabIndex : 0;
		document.getElementById("ddg_TabBox").selectedIndex = tabIndex;
	},
	
	enableApply : function(event){
		var item = event.target;
		if(item.parentNode.id && !(item.parentNode.id == "DragContextButton" || item.parentNode.id == "dragContextMenus")) return;
		if(event.originalTarget && event.originalTarget.className == "ddg-search-plugs") return;
		document.documentElement.getButton("extra1").disabled = false;
	},
	
	getLastTabs : function(){
		with(ddg_Preferences){
			document.getElementById("ddg_Gest_TabBox").selectedIndex = get('selecedGestTab', 0);
			document.getElementById("ddg_Folder_TabBox").selectedIndex = get('selecedFolderTab', 0);
			document.getElementById("ddg_Menu_TabBox").selectedIndex = get('selecedMenuTab', 0);
			var MainTabIndex = get('selecedMainTab', 0);
			document.getElementById("ddg_TabBox").selectedIndex = MainTabIndex;
			document.getElementById("ddg_ButtonBox").childNodes[MainTabIndex].checked = true;
		}
	},
	
	setLastTabs : function(){
		with(ddg_Preferences){
			set('selecedMainTab', document.getElementById("ddg_TabBox").selectedIndex);
			set('selecedGestTab', document.getElementById("ddg_Gest_TabBox").selectedIndex);
			set('selecedFolderTab', document.getElementById("ddg_Folder_TabBox").selectedIndex);
			set('selecedMenuTab', document.getElementById("ddg_Menu_TabBox").selectedIndex);
		}
	},
	
	onClose : function(){
		this.setLastTabs();
		window.removeEventListener("command", ddg_Prefs.enableApply, false);
		window.removeEventListener("change", ddg_Prefs.enableApply, false);
		window.removeEventListener("close", ddg_Prefs.onClose, false);
	},
	
	onApply : function(){
		this.checkState();
		ddg_Preferences.savePrefs();
		document.documentElement.getButton("extra1").disabled = true;
		this.ApplyChangeToBrowser();
	},
	
	onAccept : function(){
		this.checkState();
		with(ddg_Preferences){
			removeBranch();
			savePrefs();
		}
		this.onClose();
		this.ApplyChangeToBrowser();
	},
	
	ApplyChangeToBrowser : function(){
		var currentWindow = ddgUtils.MostRecentWindow('navigator:browser');
		if (currentWindow == null) return;
		currentWindow.ddg_Preferences.loadPrefs();
		currentWindow.DragdeGo.updateState();
	},
	
	exportData: function() {
		this.onApply();
		var fp = ddgUtils.initFile(ddg_StringS.getByName("setting.export.title"),
								this.ProfName.toLowerCase() + "_ddg_pref.txt");
		if (fp.show() == fp.returnCancel) return;
		
		var today = new Date();
		var str = ""
		str += "/*\r\n *  ";
		str += today.toString() + "\r\n *  ";
		str += this.ProfName + "\r\n *  ";
		str += navigator.userAgent + "\r\n */";
		str += "\r\n";
		str += "\r\n";
		
		with(ddg_Preferences){
			var prefCount = {value:0}; 
			var prefArray = pref.getChildList(ddg_prefRoot , prefCount);
			prefArray.sort();
			for each(var item in prefArray) {
				switch (pref.getPrefType(item)) {
					case pref.PREF_STRING:
						str += "user_pref('" + item + "', '";
						str += pref.getCharPref(item).replace(/\\/g, '\\\\');
						str += "');";
						break;
					case pref.PREF_INT:
						str += "user_pref('" + item + "', ";
						str += pref.getIntPref(item);
						str += ");";
						break;
					case pref.PREF_BOOL:
						str += "user_pref('" + item + "', ";
						str += pref.getBoolPref(item);
						str += ");";
						break;
				}
				str += "\r\n";
			}
		}
		str += "\r\n";
		ddgUtils.saveText(fp.file, str);
	},
	
	importData: function(bReset) {
		var fp = Cc["@mozilla.org/filepicker;1"].
				createInstance(nsCI.nsIFilePicker);
		fp.init(window, ddg_StringS.getByName("setting.import.title"), fp.modeOpen);
		fp.defaultString = this.ProfName.toLowerCase() + "_ddg_pref.txt";
		fp.defaultExtension = "txt";
		fp.appendFilters(fp.filterText);
		fp.appendFilters(fp.filterAll);
		
		if (fp.show() == fp.returnOK) {
			var prefService = Cc["@mozilla.org/preferences-service;1"].
								getService(nsCI.nsIPrefService);
			prefService.readUserPrefs(fp.file);
			this.init();
			prefService.readUserPrefs(ddgUtils.getDir("PrefF"));
			document.documentElement.getButton("extra1").disabled = false;
		}
	},
	
	restoreDefault: function() {
		if(confirm(ddg_StringS.getByName("restore.pref.warning"))){
			ddg_Preferences.removeBranch();
			this.init();
			this.ApplyChangeToBrowser();
		}
	},
	
	get ProfName(){
		var ddgProfDIR = Cc['@mozilla.org/file/directory_service;1'].
						getService(nsCI.nsIProperties);
		var fileOrDir = ddgProfDIR.get('ProfD', nsCI.nsIFile);
		return fileOrDir.leafName.replace(/^.{9}/, "");
	},
	
	addTab : function(aUrl){
		var currentWindow = ddgUtils.MostRecentWindow('navigator:browser');
		if (currentWindow != null){
			try {
		  		currentWindow.delayedOpenTab(aUrl);
			}catch(e){
				currentWindow.loadURI(aUrl);
			}
		}else{
			window.open(aUrl);
		}
	},
	
	CharMenu : {
		onLoad : function(){
			var observerService = Cc['@mozilla.org/observer-service;1'].getService(nsCI.nsIObserverService);
			observerService.notifyObservers(null, 'charsetmenu-selected', 'other');
		}
	},
	
	toolTipResizeToContents : function(obj){
		var height = parseInt(window.getComputedStyle(obj.childNodes[0], '').height) + 11;
		obj.sizeTo(obj.boxObject.width , height);
	}
}

var TimeoutCntl = {
	TimeoutPeriod:null,
	onLoad : function(){
		this.TimeoutPeriod = null;
		this.checkstate();
	},
	
	view : function(){
		document.getElementById("TimeoutTime").value = this.TimeoutPeriod/20;
	},

	checkstate : function(){
		if(this.TimeoutPeriod == null) this.TimeoutPeriod = ddg_Preferences.Prefs.TimeoutPeriod;
		this.TimeoutPeriod = (this.TimeoutPeriod >= 0 && this.TimeoutPeriod <= 2000)  ? this.TimeoutPeriod : 1000;
		var c1 = document.getElementById('EnableTimeout').checked;
		var c2 = document.getElementById('ShowDragContext').checked;
		document.getElementById('DragContextButton').disabled = !c1 || !c2;
		document.getElementById('timeout_disabled').setAttribute("disabled", !c1);
		document.getElementById('timeout_hidden').setAttribute("hidden", !c1);
		document.getElementById('timeoutminus').disabled = !c1 || this.TimeoutPeriod == 0;
		document.getElementById('timeoutplus').disabled  = !c1 || this.TimeoutPeriod == 2000;
		if(c1) this.view();
	},
	
	onchange : function(inpt) {
		if(this.TimeoutPeriod == null) this.TimeoutPeriod = ddg_Preferences.Prefs.TimeoutPeriod;
		this.TimeoutPeriod += inpt;
		this.checkstate();
	}
}

var Indicator = {
	Data : [],
	
	onLoad : function(){
		this.Data = [];
		this.checkstate();
		this._rebuildFonts();
	},
	
	_rebuildFonts: function (){
		if(ddg_Preferences.pref.prefHasUserValue("font.language.group")){
			var langGroupPref = ddg_Preferences.pref.getComplexValue("font.language.group",
								nsCI.nsISupportsString).data;
		}else{
			try{
				const aStringService = Cc["@mozilla.org/intl/stringbundle;1"].
									getService(nsCI.nsIStringBundleService);
				
				var intlMess = aStringService.createBundle("chrome://global/locale/intl.properties");
				var langGroupPref = intlMess.GetStringFromName("font.language.group");
			}catch(e){return;}
		}
		this._selectLanguageGroup(langGroupPref,
			this._readDefaultFontTypeForLanguage(langGroupPref) == "serif");
	},
	
	_selectLanguageGroup: function (aLanguageGroup, aIsSerif) {
		var fontType = aIsSerif ? "serif" : "sans-serif";
		var element = document.getElementById("fontTypeMnu");
		FontBuilder.buildFontList(aLanguageGroup, fontType, element);
		for each(var mItem in element.firstChild.childNodes)
			if(mItem.localName) mItem.setAttribute("oncommand", "Indicator.setFontType(this.value)");
		if(this.Data[5]) element.value = decodeURIComponent(this.Data[5]);
	},
	
	_readDefaultFontTypeForLanguage: function (aLanguageGroup){
		const kDefaultFontType = "font.default.%LANG%";
		var defaultFontTypePref = kDefaultFontType.replace(/%LANG%/, aLanguageGroup);
		var preference = ddg_Preferences.pref.getCharPref(defaultFontTypePref);
		return preference;
	},
	
	view : function(){
		document.getElementById("indicatorColor").color = this.Data[2];
		document.getElementById("indicatorBgColor").color = this.Data[3];
		document.getElementById("DelayTime").value = this.Data[4]/2;
		document.getElementById("opacityValue").value = this.Data[1]/10;
		document.getElementById("fontSizeValue").value = this.Data[0] + "px";
		var tipStyle = document.getElementById("indicatorText").style;
		with(tipStyle){
			fontWeight = "bold";
			padding = "3px";
			border = "1px solid #E0E0E0";
			backgroundColor = this.Data[3];
			MozBorderRadius = this.Data[0]/2 + "px";
			MozOpacity = this.Data[1]/10;
			color = this.Data[2];
			fontSize = this.Data[0] + "px";
			if(this.Data[5])
				fontFamily = decodeURIComponent(this.Data[5]);
		}
	},

	checkstate : function(){
		if(!this.Data.length) this.Data = ddg_Preferences.Prefs.tipStyle;
		this.Data[0] = (this.Data[0] >= 7 && this.Data[0] <= 40)  ? this.Data[0] : 16;
		this.Data[1] = (this.Data[1] >= 0 && this.Data[1] <= 10)  ? this.Data[1] : 5;
		this.Data[4] = (this.Data[4] >= 0 && this.Data[4] <= 200) ? this.Data[4] : 0;
		var c1 = document.getElementById('showTooltip').checked;
		document.getElementById('toolTip_disabled').setAttribute("disabled", !c1);
		document.getElementById('toolTip_hidden').setAttribute("hidden", !c1);
		document.getElementById('fontminus').disabled    = !c1 || this.Data[0] == 7;
		document.getElementById('fontplus').disabled     = !c1 || this.Data[0] == 40;
		document.getElementById('opacityminus').disabled = !c1 || this.Data[1] == 0;
		document.getElementById('opacityplus').disabled  = !c1 || this.Data[1] == 10;
		document.getElementById('timeminus').disabled    = !c1 || this.Data[4] == 0;
		document.getElementById('timeplus').disabled     = !c1 || this.Data[4] == 200;
		document.getElementById("indicatorColor").color = this.Data[2];
		document.getElementById("indicatorBgColor").color = this.Data[3];
		if(c1) this.view();
	},

	setFontType : function(itemValue){
		if(!this.Data.length) this.Data = ddg_Preferences.Prefs.tipStyle;
		this.Data[5] = encodeURIComponent(itemValue);
		this.view();
    },
	
	onchange : function(inc ,inp ,inpt) {
		if(!this.Data.length) this.Data = ddg_Preferences.Prefs.tipStyle;
		this.Data[2] = document.getElementById("indicatorColor").color;
		this.Data[3] = document.getElementById("indicatorBgColor").color;
		this.Data[0] += inc;
		this.Data[1] += inp;
		this.Data[4] += inpt;
		this.checkstate();
	}
}

function treeView(items){
	this.items = items;
	this.treebox = null;
}

treeView.prototype = {
	invalidate : function(){
		this.treebox.invalidate();
	},
	
	swap : function(idx1, idx2){
		if ((idx1 == idx2) || (idx1 < 0) || (idx2 < 0))
			return;
		
		var temp = this.items[idx1];
		
		this.items[idx1] = this.items[idx2];
		this.items[idx2] = temp;
	},
	
	insertItem : function(newItem){
		try{
			this.items.push(newItem);
			this.treebox.rowCountChanged(this.rowCount, 1);
		}catch (err){ddgUtils.Log("err insertItem\n" + e);}
	},
	
	deleteSelectedItem : function(){
		try{
			var selIdx = this.selection.currentIndex;
			if (selIdx < 0) return;
			var newItems = new Array();
			for (var i = 0; i < this.items.length; i++){
				if (i != selIdx) newItems.push(this.items[i]);
			}
			
			this.items = newItems;
			this.treebox.rowCountChanged(selIdx, -1);
			
			if (newItems.length > 0)
				this.selection.select(selIdx == 0 ? 0 : selIdx - 1);
		}catch (err){alert(err);}
	},
	
	getCellText : function(row,column){
		switch (typeof(column) == "object" ? column.id : column){
			case "name":
				return this.items[row].name;
			case "path":
				return this.items[row].path;
			default:
				return "";
		}
	},
	
	get rowCount(){
		return this.items.length;
	},
	
	setTree: function(treebox){
		this.treebox = treebox;
	},
	
	isContainer: function(row) { return false; },
	isSeparator: function(row) { return false; },
	isSorted: function(row) { return false; },
	cycleHeader: function(col, elem) {},
	getLevel: function(row) { return 0; },
	getRowProperties: function(row,props) {},
	getCellProperties: function(row,col,props) {},
	getColumnProperties: function(colid,col,props) {},
	getImageSrc: function getImageSrc(index, column) {}
};
